<?php 

if(!class_exists('DB_Connect') ) 
    include "conexion/DB_Connect.php";

require_once 'libs/vendor/autoload.php';
        
use Box\Spout\Writer\Common\Creator\WriterEntityFactory;
use Box\Spout\Common\Entity\Row;

use Box\Spout\Writer\Common\Creator\Style\StyleBuilder;
use Box\Spout\Common\Entity\Style\CellAlignment;
use Box\Spout\Common\Entity\Style\Color;


class Reports extends DB_Connect {
        
    /**
     * Constructor de clase
     */
    function my_status_header($setHeader=null) {
        static $theHeader=null;
        //if we already set it, then return what we set before (can't set it twice anyway)
        if($theHeader) {return $theHeader;}
        $theHeader = $setHeader;
        header('HTTP/1.1 '.$setHeader);
        return $setHeader;
    } 
    
    /**
     * obtiene un solo registro dado su ID
     * @param int $id identificador unico de registro
     * @return Array array con los registros obtenidos de la base de datos
     */


    public function getRptsimpleCount($get_data)
       {      

                $info=json_decode($get_data);

        $sqlWhere="";
        $sqlInner="";
        $isLimit=true;
        $sqlHaving="";

        if($info->colegio!="")
        {
            $sqlWhere.=" AND N.IDCOLEGIO=".$info->colegio;
        
        }
        if($info->notaria!="")
        {
            $sqlWhere.=" AND D.IDNOTARIA=".$info->notaria;
        }  

        if($info->acto!="")
        {
            $sqlWhere.=" AND O.IDACTOJURIDICO=".$info->acto;
        }  



        if($info->tipoInstrumento!="")
        {
            $sqlWhere.=" AND D.IDINSTRUMENTO=".$info->tipoInstrumento;
        }  
        
        if($info->fechaInicio!="" && $info->fechaFin!="")
        {
            $inicio = date("d/m/Y", strtotime($info->fechaInicio));
            $fin = date("d/m/Y", strtotime($info->fechaFin));

            $sqlWhere.=" AND D.FECHAAUTORIZACION BETWEEN '".$inicio."' AND '".$fin."' ";
        }


        $sqlPaginator="";
        $pageInit=0;
        if($info->pageIndex!="" && $info->pageIndex>0)
            $pageInit=((int)$info->pageIndex*(int)$info->pageSize)+1;
        
        $valueMax= ((int)$info->pageSize*((int)$info->pageIndex+1));
        
        if($info->minPatrimonial!="" || $info->maxPatrimonial!="")
            $isLimit=false;

        if(trim($sqlWhere)!="")
            $isLimit=false;

        if($isLimit==true)
        {
            $sqlPaginator=" WHERE   to_char(FECHAAUTORIZACION, 'mm')=2  AND to_char(FECHAAUTORIZACION, 'yyyy')=2021 ";
        }
        

        if($info->minPatrimonial!="" || $info->maxPatrimonial!="")
        {
            $sqlInner.=" INNER JOIN SISGEN.MEDIODEPAGO M ON OX.ID=M.IDOPERACION "  ; 
            $sqlHaving.="HAVING ";         
        }

        if($info->minPatrimonial!=""  && $info->maxPatrimonial!="")
            $sqlHaving.="  SUM(M.CUANTIA)>=".$info->minPatrimonial." AND SUM(M.CUANTIA)<= ".$info->maxPatrimonial;
        else  if($info->minPatrimonial!="" && $info->maxPatrimonial=="" )
            $sqlHaving.="  SUM(M.CUANTIA)>=".$info->minPatrimonial;
        else if($info->maxPatrimonial!="" && $info->minPatrimonial=="")
             $sqlHaving.=" SUM(M.CUANTIA)<=".$info->maxPatrimonial;
       
       
       $db=$this->connect();
       
$sql="
SELECT COUNT(*) AS TOTAL FROM (
SELECT  TBL2.NUMERODEKARDEX,FECHAAUTORIZACION,TIPOINSTRUMENTO,NUMEROINSTRUMENTO,SCORING,
NOTARIA,CANTIDAD_INTERVINIENTES,
LISTAGG(AX.DESCRIPCION, ',') WITHIN GROUP (ORDER BY AX.DESCRIPCION) AS NOMBREACTO
FROM (
SELECT  TBL1.*,COUNT(*) AS CANTIDAD_INTERVINIENTES FROM (
          SELECT  D.ID AS IDX, D.NUMERODEKARDEX,FECHAAUTORIZACION,T.ABREV AS TIPOINSTRUMENTO,
D.NUMERO AS NUMEROINSTRUMENTO,D.SCORING,
N.DESCRIPCION AS NOTARIA 
FROM SISGEN.DOCUMENTONOTARIAL D 
INNER JOIN SISGEN.TIPOINSTRUMENTO T ON D.IDINSTRUMENTO=T.ID
LEFT JOIN SISGEN.OPERACION O ON D.ID=O.IDDOCUMENTONOTARIAL
INNER JOIN SISGEN.NOTARIA N ON D.IDNOTARIA=N.ID
LEFT JOIN SISGEN.INTERVINIENTE IX ON  O.ID=IX.IDOPERACION
LEFT JOIN SISGEN.REPRESENTANTE RR ON IX.ID=RR.IDINTERVINIENTE 
LEFT JOIN SISGEN.SUJETO SX ON SX.ID=IX.IDPERSONA OR SX.ID=RR.IDPERSONA
WHERE D.ID>0  ".$sqlWhere."
GROUP BY D.ID,NUMERODEKARDEX,FECHAAUTORIZACION,T.ABREV,D.NUMERO,D.SCORING,N.DESCRIPCION, SX.ID
ORDER BY IDX,NOTARIA,T.ABREV,D.NUMERO,FECHAAUTORIZACION
)  TBL1  GROUP BY IDX,NUMERODEKARDEX,FECHAAUTORIZACION,TIPOINSTRUMENTO,NUMEROINSTRUMENTO,SCORING,NOTARIA
) TBL2 
LEFT JOIN SISGEN.OPERACION OX ON TBL2.IDX=OX.IDDOCUMENTONOTARIAL 
LEFT JOIN SISGEN.ACTOJURIDICO AX ON OX.IDACTOJURIDICO=AX.ID
".$sqlInner."
GROUP BY (NUMERODEKARDEX,FECHAAUTORIZACION,TIPOINSTRUMENTO,NUMEROINSTRUMENTO,SCORING,NOTARIA,CANTIDAD_INTERVINIENTES)
".$sqlHaving."
)  TBL3 ".$sqlPaginator."
 ";


 $stid = oci_parse($db,$sql);

       oci_execute($stid);
       $row = oci_fetch_assoc($stid);
       $total=$row["TOTAL"];


        oci_free_statement($stid);
        oci_close($db);   
        return $total;     
}



    public function getRptsimple($get_data)
       {      

        $info=json_decode($get_data);

        $sqlWhere="";
        $sqlInner="";
        $isLimit=true;
        $sqlHaving="";

        if($info->colegio!="")
        {
            $sqlWhere.=" AND N.IDCOLEGIO=".$info->colegio;
        
        }
        if($info->notaria!="")
        {
            $sqlWhere.=" AND D.IDNOTARIA=".$info->notaria;
        }  

        if($info->acto!="")
        {
            $sqlWhere.=" AND O.IDACTOJURIDICO=".$info->acto;
        }  



        if($info->tipoInstrumento!="")
        {
            $sqlWhere.=" AND D.IDINSTRUMENTO=".$info->tipoInstrumento;
        }  
        
        if($info->fechaInicio!="" && $info->fechaFin!="")
        {
            $inicio = date("d/m/Y", strtotime($info->fechaInicio));
            $fin = date("d/m/Y", strtotime($info->fechaFin));

            $sqlWhere.=" AND D.FECHAAUTORIZACION BETWEEN '".$inicio."' AND '".$fin."' ";
        }


        $sqlPaginator="";
        $pageInit=0;
        if($info->pageIndex!="" && $info->pageIndex>0)
            $pageInit=((int)$info->pageIndex*(int)$info->pageSize)+1;
        
        $valueMax= ((int)$info->pageSize*((int)$info->pageIndex+1));
        
        if($info->minPatrimonial!="" || $info->maxPatrimonial!="")
            $isLimit=false;

        if(trim($sqlWhere)!="")
            $isLimit=false;

        if($isLimit==true)
        {
            $sqlPaginator=" WHERE ROWNUM<=".$valueMax." AND to_char(FECHAAUTORIZACION, 'mm')=2  AND to_char(FECHAAUTORIZACION, 'yyyy')=2021 ";
        }else{
             $sqlPaginator="WHERE  ROWNUM<=".$valueMax;
        }
        

        if($info->minPatrimonial!="" || $info->maxPatrimonial!="")
        {
            $sqlInner.=" INNER JOIN SISGEN.MEDIODEPAGO M ON OX.ID=M.IDOPERACION "  ; 
            $sqlHaving.="HAVING ";         
        }

        if($info->minPatrimonial!=""  && $info->maxPatrimonial!="")
            $sqlHaving.="  SUM(M.CUANTIA)>=".$info->minPatrimonial." AND SUM(M.CUANTIA)<= ".$info->maxPatrimonial;
        else  if($info->minPatrimonial!="" && $info->maxPatrimonial=="" )
            $sqlHaving.="  SUM(M.CUANTIA)>=".$info->minPatrimonial;
        else if($info->maxPatrimonial!="" && $info->minPatrimonial=="")
             $sqlHaving.=" SUM(M.CUANTIA)<=".$info->maxPatrimonial;
       
       
       $db=$this->connect();
       
       $sql="
       SELECT * FROM (
SELECT ROWNUM as RNUM,TBL3.* FROM (
SELECT  TBL2.NUMERODEKARDEX,FECHAAUTORIZACION,TIPOINSTRUMENTO,NUMEROINSTRUMENTO,SCORING,
NOTARIA,CANTIDAD_INTERVINIENTES,
LISTAGG(AX.DESCRIPCION, ',') WITHIN GROUP (ORDER BY AX.DESCRIPCION) AS NOMBREACTO
FROM (
SELECT  TBL1.*,COUNT(*) AS CANTIDAD_INTERVINIENTES FROM (
          SELECT  D.ID AS IDX, D.NUMERODEKARDEX,FECHAAUTORIZACION,T.ABREV AS TIPOINSTRUMENTO,
D.NUMERO AS NUMEROINSTRUMENTO,D.SCORING,
N.DESCRIPCION AS NOTARIA 
FROM SISGEN.DOCUMENTONOTARIAL D 
INNER JOIN SISGEN.TIPOINSTRUMENTO T ON D.IDINSTRUMENTO=T.ID
LEFT JOIN SISGEN.OPERACION O ON D.ID=O.IDDOCUMENTONOTARIAL
INNER JOIN SISGEN.NOTARIA N ON D.IDNOTARIA=N.ID
LEFT JOIN SISGEN.INTERVINIENTE IX ON  O.ID=IX.IDOPERACION
LEFT JOIN SISGEN.REPRESENTANTE RR ON IX.ID=RR.IDINTERVINIENTE 
LEFT JOIN SISGEN.SUJETO SX ON SX.ID=IX.IDPERSONA OR SX.ID=RR.IDPERSONA
WHERE D.ID>0  ".$sqlWhere."
GROUP BY D.ID,NUMERODEKARDEX,FECHAAUTORIZACION,T.ABREV,D.NUMERO,D.SCORING,N.DESCRIPCION, SX.ID
ORDER BY IDX,NOTARIA,T.ABREV,D.NUMERO,FECHAAUTORIZACION
)  TBL1  GROUP BY IDX,NUMERODEKARDEX,FECHAAUTORIZACION,TIPOINSTRUMENTO,NUMEROINSTRUMENTO,SCORING,NOTARIA
) TBL2 
LEFT JOIN SISGEN.OPERACION OX ON TBL2.IDX=OX.IDDOCUMENTONOTARIAL 
LEFT JOIN SISGEN.ACTOJURIDICO AX ON OX.IDACTOJURIDICO=AX.ID
".$sqlInner."
GROUP BY (NUMERODEKARDEX,FECHAAUTORIZACION,TIPOINSTRUMENTO,NUMEROINSTRUMENTO,SCORING,NOTARIA,CANTIDAD_INTERVINIENTES)
".$sqlHaving."
)  TBL3 ".$sqlPaginator."
) TBL4 WHERE RNUM>=".$pageInit."
       ";


 $stid = oci_parse($db,$sql);
       /*
       $stid = oci_parse($db, "
SELECT * FROM (
SELECT ROWNUM as RNUM,tbl.* FROM (
        SELECT  D.ID AS IDX, D.NUMERODEKARDEX,FECHAAUTORIZACION,T.ABREV AS TIPOINSTRUMENTO,
D.NUMERO AS NUMEROINSTRUMENTO,D.SCORING,
N.DESCRIPCION AS NOTARIA,
LISTAGG(A.DESCRIPCION, ',') WITHIN GROUP (ORDER BY A.DESCRIPCION) AS NOMBREACTO ".$sqlSelect."
FROM SISGEN.DOCUMENTONOTARIAL D 
INNER JOIN SISGEN.TIPOINSTRUMENTO T ON D.IDINSTRUMENTO=T.ID
LEFT JOIN SISGEN.OPERACION O ON D.ID=O.IDDOCUMENTONOTARIAL
INNER JOIN SISGEN.NOTARIA N ON D.IDNOTARIA=N.ID
LEFT JOIN SISGEN.ACTOJURIDICO A ON O.IDACTOJURIDICO=A.ID
".$sqlInner."
WHERE D.ID>0  ".$sqlWhere."
 GROUP BY D.ID,NUMERODEKARDEX,FECHAAUTORIZACION,T.ABREV,
D.NUMERO,D.SCORING,N.DESCRIPCION ".$sqlGroup."
ORDER BY IDX,NOTARIA,T.ABREV,D.NUMERO,FECHAAUTORIZACION
)  tbl  ".$sqlPaginator."
) WHERE RNUM>=".$pageInit);

*/       oci_execute($stid);
       $data=[];
        while (($row = oci_fetch_assoc($stid)) != false) {
            $data[]=$row;
        }

        oci_free_statement($stid);
        oci_close($db);   
        return $data;     
}
public function cerrarSesion()
{
    session_start();
    session_destroy();
    return  array('0' =>'session cerrada');
}

    public function getValidationSession(){
//        $_SESSION["user"]="jnca";
        session_start();
        $data=[];
        
        if(isset($_SESSION["user"])){
            $data= array(0 =>'1',1=>$_SESSION["user"],'user'=>$_SESSION["user"]);
        }   else
            $data= array(0 =>'0',1 =>'Invitado','user'=>"Invitado");

//            $data= array(0 =>'0');
        

        return $data;
    }
    public function getLogin($user,$password)
    { 
        session_start();
        $data=[];
        $user=strtoupper($user);
        $password=strtoupper($password);
        
        if($user=="ADMIN" && $password=="ADMIN"){
            $data=array(0 =>'1' ,'error'=>'0','msg'=>'correcto','user'=>$user);
            $_SESSION["user"]=$user;
        }else
            $data=array(0 =>'0' ,'error'=>'1','msg'=>'datos incorrectos','user'=>$user);

           
         return $data;
    }

    public function getRptGenerarsimple($get_data)
       {        


        $info=json_decode($get_data);
        
        $sqlWhere="";
        $sqlInner="";
        $isLimit=true;
        $sqlSelect="";
        $sqlGroup="";
        $sqlLimit="";


        if($info->colegio!="")
        {
            $sqlWhere.=" AND N.IDCOLEGIO=".$info->colegio;
        
        }
        if($info->notaria!="")
        {
            $sqlWhere.=" AND D.IDNOTARIA=".$info->notaria;
        }  

        if($info->acto!="")
        {
            $sqlWhere.=" AND O.IDACTOJURIDICO=".$info->acto;
        }  



        if($info->tipoInstrumento!="")
        {
            $sqlWhere.=" AND D.IDINSTRUMENTO=".$info->tipoInstrumento;
        }  
        
        if($info->fechaInicio!="" && $info->fechaFin!="")
        {
            $inicio = date("d/m/Y", strtotime($info->fechaInicio));
            $fin = date("d/m/Y", strtotime($info->fechaFin));

            $sqlWhere.=" AND D.FECHAAUTORIZACION BETWEEN '".$inicio."' AND '".$fin."' ";
        }
 

        $sqlPaginator="";
        $pageInit=0;
        if($info->pageIndex!="" && $info->pageIndex>0)
            $pageInit=((int)$info->pageIndex*(int)$info->pageSize)+1;
        
        $valueMax= ((int)$info->pageSize*((int)$info->pageIndex+1));
        
        if($info->minPatrimonial!="" || $info->maxPatrimonial!="")
            $isLimit=false;

         if(trim($sqlWhere)!="")
            $isLimit=false;

        if($isLimit==true)
        {
            $sqlPaginator=" WHERE to_char(FECHAAUTORIZACION, 'mm')=2  AND to_char(FECHAAUTORIZACION, 'yyyy')=2021 ";
        }else 
            $sqlPaginator.=" WHERE NUMERODEKARDEX IS NOT NULL "; 
 
       if($info->minPatrimonial!="" )
        {
            $sqlPaginator.=" AND MPATRIMONIAL>=".$info->minPatrimonial;
        }
        if($info->maxPatrimonial!="" )
        {
            $sqlPaginator.=" AND MPATRIMONIAL<=".$info->maxPatrimonial;
        }

        if($info->minPatrimonial!="" || $info->maxPatrimonial!="")
        {
            $sqlSelect.=", SUM(M.CUANTIA) AS MPATRIMONIAL ";
            $sqlInner.=" INNER JOIN SISGEN.MEDIODEPAGO M ON O.ID=M.IDOPERACION "  ;          
            $sqlGroup.=", O.NOMBRECONTRATO ";
        }
        
       
        
       
       
       $db=$this->connect();
       

       $stid = oci_parse($db, "
SELECT * FROM (
SELECT ROWNUM as RNUM,tbl.* FROM (
        SELECT  D.ID AS IDX, D.NUMERODEKARDEX,FECHAAUTORIZACION,T.ABREV AS TIPOINSTRUMENTO,
D.NUMERO AS NUMEROINSTRUMENTO,D.SCORING,
N.DESCRIPCION AS NOTARIA,C.NOMBRE AS COLEGIO,
LISTAGG(A.DESCRIPCION, ',') WITHIN GROUP (ORDER BY A.DESCRIPCION) AS NOMBREACTO ".$sqlSelect."
FROM SISGEN.DOCUMENTONOTARIAL D 
INNER JOIN SISGEN.TIPOINSTRUMENTO T ON D.IDINSTRUMENTO=T.ID
LEFT JOIN SISGEN.OPERACION O ON D.ID=O.IDDOCUMENTONOTARIAL
LEFT JOIN SISGEN.ACTOJURIDICO A ON O.IDACTOJURIDICO=A.ID
INNER JOIN SISGEN.NOTARIA N ON D.IDNOTARIA=N.ID
INNER JOIN SISGEN.COLEGIO C ON N.IDCOLEGIO=C.ID

".$sqlInner."
WHERE D.ID>0  ".$sqlWhere."
 GROUP BY D.ID,NUMERODEKARDEX,FECHAAUTORIZACION,T.ABREV,
D.NUMERO,D.SCORING,C.NOMBRE,N.DESCRIPCION ".$sqlGroup."
ORDER BY NOTARIA,T.ABREV,D.NUMERO,FECHAAUTORIZACION
)  tbl  ".$sqlPaginator."
) ");



        $nameRpt="rpt/report".uniqid().".xlsx";
        //$nameRpt="test.xlsx";
        $writer = WriterEntityFactory::createXLSXWriter();

        $writer->openToFile($nameRpt); // write data to a file or to a PHP stream

        /** Create a style with the StyleBuilder */
        $style = (new StyleBuilder())
             ->setFontBold()
//           ->setFontSize(15)
//           ->setFontColor(Color::BLUE)
 //          ->setShouldWrapText()
 //          ->setCellAlignment(CellAlignment::RIGHT)
 //          ->setBackgroundColor(Color::YELLOW)
           ->build();

    //    $row = WriterEntityFactory::createRowFromArray(['Carl', 'is', 'great'], $style);

        $cells_titulo = [
            "COLEGIO",
            "NOTARIA",
            "N° KARDEX",
            "FECHA ESCRITURA",
            "TIPO INSTR.",
            "N° INSTRUMENTO",
            "NOMBRE ACTO",
            "SCORING"
        ];

 //       $singleRow = WriterEntityFactory::createRow($cells_titulo);
        $singleRow = WriterEntityFactory::createRowFromArray($cells_titulo,$style);
        $writer->addRow($singleRow);
        oci_execute($stid);
        $data=[];
        $i=2;
        while (($row = oci_fetch_assoc($stid)) != false) {
            $values = [$row["COLEGIO"],$row["NOTARIA"],$row["NUMERODEKARDEX"],$row["FECHAAUTORIZACION"],$row["TIPOINSTRUMENTO"],$row["NUMEROINSTRUMENTO"],$row["NOMBREACTO"],$row["SCORING"]];
            $rowFromValues = WriterEntityFactory::createRowFromArray($values);
            $writer->addRow($rowFromValues);
        }

        $writer->close();
        oci_free_statement($stid);
        oci_close($db);

        return $nameRpt;

    }




public function getColegios($qBuscar)
{
    $db=$this->connect();
    $sql="SELECT ID,NOMBRE FROM SISGEN.COLEGIO ";
    if($qBuscar!="")
    {
        $sql.=" WHERE UPPER(NOMBRE) LIKE '%".strtoupper($qBuscar)."%'";
    }
       $stid = oci_parse($db, $sql);
       oci_execute($stid);
       $data=[];
        while (($row = oci_fetch_assoc($stid)) != false) {
            $data[]=$row;       
        }

        oci_free_statement($stid);
        oci_close($db);   
        return $data;   
}

public function getNotarias($qBuscar,$idColegio)
{
    $sqlBuscar="";
    if($qBuscar!="")
    {
        $sqlBuscar.=" WHERE UPPER(N.DESCRIPCION) LIKE '%".strtoupper($qBuscar)."%'";
    }


    if($idColegio!="")
    {
        if($sqlBuscar=="")
            $sqlBuscar.=" WHERE ";
        else
            $sqlBuscar.=" AND ";
            
        $sqlBuscar.="  N.IDCOLEGIO=".$idColegio;
    }

    $db=$this->connect();
    $sql="SELECT * FROM (
SELECT N.ID,UPPER(N.DESCRIPCION) AS NOMBRE FROM SISGEN.NOTARIA  N
".$sqlBuscar."
ORDER BY N.DESCRIPCION
) WHERE ROWNUM<=20
";
       $stid = oci_parse($db, $sql);
       oci_execute($stid);
       $data=[];
        while (($row = oci_fetch_assoc($stid)) != false) {
            $data[]=$row;       
        }

        oci_free_statement($stid);
        oci_close($db);   
        return $data;   
}

public function getActos($qBuscar)
{
    $sqlBuscar="";
    if($qBuscar!="")
    {
        $sqlBuscar.=" WHERE UPPER(A.DESCRIPCION) LIKE '%".strtoupper($qBuscar)."%'";
    }

    $db=$this->connect();
    $sql="SELECT * FROM (
SELECT A.ID,A.DESCRIPCION AS NOMBRE from SISGEN.ACTOJURIDICO A
".$sqlBuscar."
ORDER BY A.DESCRIPCION
) WHERE ROWNUM<=20
";


       $stid = oci_parse($db, $sql);
       oci_execute($stid);
       $data=[];
        while (($row = oci_fetch_assoc($stid)) != false) {
            $data[]=$row;       
        }

        oci_free_statement($stid);
        oci_close($db);   
        return $data;   
}

public function getBanderas($qBuscar)
{
        $sqlBuscar="";
    if($qBuscar!="")
    {
        $sqlBuscar.=" WHERE UPPER(T.BANDERA) LIKE '%".strtoupper($qBuscar)."%'";
    }

    $db=$this->connect();
    $sql="SELECT * FROM (
SELECT T.ID,T.BANDERA AS NOMBRE from SISGEN.TIPOLISTA T
".$sqlBuscar."
ORDER BY T.BANDERA
) WHERE ROWNUM<=20
";


       $stid = oci_parse($db, $sql);
       oci_execute($stid);
       $data=[];
        while (($row = oci_fetch_assoc($stid)) != false) {
            $data[]=$row;       
        }

        oci_free_statement($stid);
        oci_close($db);   
        return $data;   

}

public function getInstrumentos($qBuscar)
{
     $db=$this->connect();
    $sql="SELECT ID,DESCRIPCION AS NOMBRE FROM SISGEN.TIPOINSTRUMENTO
";
    if($qBuscar!="")
    {
        $sql.=" WHERE UPPER(DESCRIPCION) LIKE '%".strtoupper($qBuscar)."%'";
    }
       $stid = oci_parse($db, $sql);
       oci_execute($stid);
       $data=[];
        while (($row = oci_fetch_assoc($stid)) != false) {
            $data[]=$row;       
        }

        oci_free_statement($stid);
        oci_close($db);   
        return $data;    
}

public function getListIps()
{
            $db=$this->connect();
           $result = $db->query('SELECT ip FROM acceso_ip where estado=1');
           $all = $result->fetch_all(MYSQLI_ASSOC);          
            $result->close();
            return $all;
}
  

public function cellColor($cells,$color,$objPHPExcel){
    $objPHPExcel->getActiveSheet()->getStyle($cells)->getFill()->applyFromArray(array(
        'type' => PHPExcel_Style_Fill::FILL_SOLID,
        'startcolor' => array(
             'rgb' => $color
        )
    ));
}

}
?>